package boxing
import java.lang.Thread

/**
 * Created by IntelliJ IDEA.
 * User: Mikkel
 * Date: 29-02-12
 * Time: 19:00
 * To change this template use File | Settings | File Templates.
 */

trait Job {

  def init() {}
  def startJob() {}
  def isCanceled():Boolean;
  def setCanceled(canceled:Boolean);
  def getName():String;
}
class DefaultJob(val name:String) extends Job {
  protected var canceled:Boolean = false;
  override def getName()=name;
  def isCanceled()=canceled;
  def setCanceled(canceled:Boolean) {this.canceled=canceled;}
  override def toString() = {"Job: "+name+" Canceled: "+isCanceled()}

}
class JobManager {
   var jobs:List[Job]  = List[Job]();
   def addJob(job:Job) {
     jobs ::=job;

     new Thread(new Runnable {
       def run() {
         job.init()
         job.startJob()
       }
     }).start();
    }
  def getJobs():List[Job] = jobs;
  def removeFinishedJobs():Unit = {
    jobs = jobs.filter(!_.isCanceled());
    jobs.foreach(x=>println(x))

    
  }
}
import scala.collection.mutable._
class JobQueue {
  def  setCanceled(jobName:String) {
    getJobs().foreach(x=>if(x.getName().equals(jobName)) x.setCanceled(true));
  }
  var jobs  = Queue[Job]();
  var currentJob:Job = null;
  def addJob(job:Job) {
    jobs+=job;
    
  }
  def getCurrentJob() = currentJob;
  def runJobs() {
      while(!jobs.isEmpty) {
        currentJob =  jobs.dequeue;
        if(!currentJob.isCanceled()) {
          currentJob.startJob();
          println("RUNNING JOB "+currentJob.getName())
        }

      }
    currentJob=null;
    
  }
  def getJobs():List[Job] = jobs.toList;
}