package boxing.brain.scala
 
import scala.collection.JavaConversions._
import boxing._
import brain.BrainHelper
import java.awt.Rectangle


/**
 * Created by IntelliJ IDEA.
 * User: mikler
 * Date: 26-07-12
 * Time: 14:21
 * To change this template use File | Settings | File Templates.
 */

class ScalaBrain(boxer1:Boxer,boxer2:Boxer,fight:Match) extends IPlayerControl {
  val brainHelper = new BrainHelper();
  var currentMove:Move = null;
  def close: Unit =  {}
  var lastMove:Move = null;
  def getCurrentMove():Move = {
    currentMove = boxer1.getCurrentMove;

      if(currentMove.isMove) {
        println("SI MOVE MAKE NULL");
        currentMove = null;
      }else
      if(currentMove.hasFinished) {
        println("**HAS FINISHED "+currentMove)
        currentMove = null;
      }else
      if(currentMove.isBlocked) {
        currentMove = null;
      }else
      if(currentMove.isBlock) {
        currentMove = null;
      }else
    if(currentMove.isMove&currentMove.getCurrentPartialMove().isPowerSupply) {
      currentMove = null;
    }else
    if(currentMove.getCurrentPartialMove().getPower() > 0) {
      currentMove = null;
    }else
      if(currentMove==lastMove&currentMove.getCurrentPartialMove.isPowerSupply) {
        currentMove = null;
      }
      //if (!currentMove.isMove&currentMove.getCurrentPartialMove().isPowerSupply & !currentMove.hasFinished() & !currentMove.isBlocked & !(currentMove.getCurrentPartialMove().getPower() > 0)) {
      //currentMove;
    if(currentMove!=null) {
      //println("CURRENT MOVE = "+currentMove)
      //println("IS MOVE = "+currentMove.isMove)
      lastMove = currentMove;

    }

    currentMove;
    //null;

  }
  def getPunch():Move  = {
          var punches = getPunchesThatConnects(boxer1,boxer2);
          val p = getRandom(punches);
          getMove(p.asInstanceOf[String]);
     }

  def getBestDefence(punches:List[String]) =  {
      var r:String = null;
      r = "crossedarms";
      if(isUpright(boxer1)) {
        if(contains(punches,"cross")|contains(punches,"jab")) {
          r = "coverup";
          if(isBlocking(boxer1)) {
            r = getRandom(List("walking_forward","walking_back")).asInstanceOf[String]
          }

        }else
        if(contains(punches,"uppercut")|contains(punches,"hook")) {
            r = "crossedarms";
          if(isCrossedarms(boxer1)) {
            r = getRandom(List("walking_forward","walking_forward","walking_back")).asInstanceOf[String]
          }
        }
      }

    r;
  }
  def contains(l:List[String],s:String) = {
    l.find(x=>x.contains(s)).size>0;

  }
  def getDefense():Move =  {
      var oppPunches = getPunchesThatConnects(boxer2,boxer1);
      var d = getBestDefence(oppPunches);
      if(d!=null) {
        getMove(d);
      }else {
        null;
      }
  }
  def getDefense2():Move =  {
        var oppPunches = getPunchesThatConnects(boxer2,boxer1);
        var defences = getAvailableDefenses(boxer1);
        //defences.map(x=>protectsAgainst(oppPunches,x)).flatMap();
        var defenceList =  oppPunches.map(x=>protectsAgainst(defences,x)).flatMap(x=>x);
        var notConnects =findDoesNotConnect(toMoves(boxer2,oppPunches),toMoves(boxer1,defences));
        println("AVAILABLE DEFENCES= = "+defences)
        println("PUNCHLIST = = "+oppPunches)
        println("DEFENCELIST = "+defenceList)
        println("NOT CONNECTS = "+notConnects)

        var  merged = defenceList// ++ notConnects;
        var d = getRandom(merged);
        println("MERGED= "+defenceList)
        if(d!=null) {
          getMove(d.asInstanceOf[Tuple2[String, String]]._1);;
        }else {
          null;
        }



  }

  def findDoesNotConnect(punches:List[Move],moves:List[Move])  = {
      var result = new scala.collection.mutable.ListBuffer[Tuple2[String, String]]();
      for(punch: Move<- punches) {
      for(defence: Move<- moves) {
            if(!doesPunchConnect(punch,defence))  {
              println("DOES NOT CONNECT "+punch+ " "+defence)
              result.add(Tuple2[String, String](defence.getName,punch.getName));
            }else {
               //println("**DOES CONNECT "+punch.getName+ " "+defence.getName)
            }
      }
   }
   result.toList;
  }
  def doesPunchConnect(punch:Move,move:Move) = brainHelper.doesPunchConnect(punch,move);
  def protectsAgainst(defence:List[String],punch:String):List[Tuple2[String, String]] = {
    defence.filter(x=>protectsAgainst(punch,x)).map(x=>Tuple2[String, String](x,punch));
  }
  def toMoves(boxer:Boxer,moveNames:List[String]) = moveNames.map(x=>boxer.getMove(x));



  def protectsAgainst(punch:String,defence:String):Boolean = {
      val punchMove = getMove(punch);
      val defenceMove = getMove(defence);
      if(punchMove==null) {
        println("NOT FOUND MOVE :"+punch);
        true;
      }else {
        defenceMove.protectsAgaints(punchMove);
      }

  }
  def  getRandom(l:List[Any]) ={
         if(l.size>0) {
          var i = (Math.random*l.size).asInstanceOf[Int];
          l(i);
         }else {
          null;
       }
  }

  def getMove() =  {
     var control = 0;
    var move = getCurrentMove();
        if(move==null) {
          if(math.random<0.1) {

            move = getPunch();
            println("GOT NEW PUNCH "+move)
          }else {
            move = getDefense();
          }
        }else {
          control = move.getFirstControl;
         }


        //if(Math.random>0.1) control = 8;
        if(move!=null) control = move.getFirstControl;

    control;
  }
  def getControl: Int = {
        var control = 0;
        if (Math.abs(boxer1.getX - boxer2.getX) > 200) {
          control = 6
       }else {
          control = getMove();

        }
    control;
  }
 def canBoxerHitWith(punchName:String,b1:Boxer, b2:Boxer) = {
   var punch = b1.getMove(punchName);
   if(!punch.isPunch) {
     false;
   }else {

   }
   false;
 }
  def getPunchesThatConnects(boxer:Boxer,opp:Boxer) = getAvailablePunches(boxer1).filter(x=>brainHelper.doesPunchConnect(boxer.getMove(x),opp.getCurrentMove));


 def getAvailablePunches(boxer:Boxer) = {
     var currentMove =  boxer.getCurrentMove.getName();
     var moves=  List[String]() ;
     if(isUpright(boxer.getCurrentMove.getName)) {
            moves = List("jab","cross","shortuppercut","corkscrew","lefthook","longuppercut")
     }
    moves;
 }

  def getAvailableDefenses(boxer:Boxer) = {
     var currentMove =  boxer.getCurrentMove.getName();
     var moves=  List[String]() ;
     var move = boxer.getCurrentMove.getName;
     if(isUpright(move)) {
            moves= List("coverup","snapback","walking_forward","walking_back","normalstance","crossedarms","bob")
     }
    if(isBobbing(move)) {
      println("**********************IS BOBBING");
      moves= List("bob","normalstance")
    }
    moves;
 }
  def isBlocking(boxer:Boxer)= {
     boxer.getCurrentMove.getName.contains("coverup");
  }
  def isCrossedarms(boxer:Boxer)= {
       boxer.getCurrentMove.getName.contains("crossedarms");
  }
  def isUpright(boxer:Boxer):Boolean = {
     isUpright(boxer.getCurrentMove.getName)
  }
 def isUpright(name:String):Boolean  = {
     name.contains("walk_forward")|name.contains("walk_back")|name.contains("coverup")|name.contains("crossed_arms")|name.contains("normalstance")|name.contains("crossedarms");
  }
  def isBobbing(name:String) = {
      name.contains("bob");
  }

 def getOppPunches()  =  {
    boxer2.getCurrentMove.getCurrentPartialMove.getPossibleMoves.getPunches.toIterator.map(x=>x.asInstanceOf[Move].getName)
 }
  def getMove(name:String) = boxer1.getMove(name);
  def getOppMove(name:String) = boxer2.getMove(name);
  def getOppDefenses()  =  {
    boxer2.getCurrentMove.getCurrentPartialMove.getPossibleMoves.getDefence.toIterator.map(x=>x.asInstanceOf[Move].getName)
 }

 def getPunches()  =  {
    boxer1.getCurrentMove.getCurrentPartialMove.getPossibleMoves.getPunches.toIterator.map(x=>x.asInstanceOf[Move].getName)
 }
  def getDefenses()  =  {
    boxer1.getCurrentMove.getCurrentPartialMove.getPossibleMoves.getDefence.toIterator.map(x=>x.asInstanceOf[Move].getName)
 }
  def isClosed: Boolean  = false;


}