package boxing.forum

import boxing.server.RatingMember
import boxing.server.SQLBase
import com.mysql.jdbc.jdbc2.optional.MysqlConnectionPoolDataSource
import org.omg.CORBA.PolicyListHelper
import org.springframework.jdbc.support.rowset.SqlRowSet
import javax.sql.DataSource
import org.springframework.jdbc.core.JdbcTemplate
import scala.collection.JavaConversions._
import java.util.ArrayList
import boxing.{JobQueue, DefaultJob, JobManager}
;


class User extends java.io.Serializable {
  var id:Int = 0;
  var posts = 0;
  var name:String = null;
  var bio:String = null;
  def getBio()=if(bio!=null) bio else "";
   
  override def equals(obj:Any) = {
    if(!obj.isInstanceOf[User]) false
     obj.asInstanceOf[User].id==id;
  }
  override def hashCode() = {
    id;
  }
  override def toString: String = id + ":" + name +"(posts "+posts+")"
}
class Topic extends java.io.Serializable {
  var topic_id = 0;
  var id = 0;
  var userId:Int = 0
  var title:String = null
}
class Post extends java.io.Serializable {
  var userId = 0;
  var id:Int = 0
  var ip:String = null
  var text:String = null;
  override def toString = id+ "  "+text;
}
/**
 * Created by IntelliJ IDEA.
 * User: Mikkel
 * Date: 26-02-12
 * Time: 18:06
 * To change this template use File | Settings | File Templates.
 */
class ForumFunctions extends SQLBase {

    var pool: MysqlConnectionPoolDataSource = new MysqlConnectionPoolDataSource
    pool.setUrl("jdbc:mysql://localhost:3306/jforum?max-connections=10&min-connections=2&inactivity-timeout=30")
    pool.setUser("root")
    pool.setPassword("")
    pool.setAutoReconnect(true)
    


  def getUser(username: String): User = {
    var sql: String = "select * from jforum_users where username like binary '" + username + "'"
    var rs: SqlRowSet = executeQuery(sql)

    var user = if (rs.next) {
      return getUser(rs)
    }else {
      null;
    }
    user;
  }
def getUser(userId: Int): User = {
    var sql: String = "select * from jforum_users where user_id='" + userId+ "'"
    var rs: SqlRowSet = executeQuery(sql)

    var user = if (rs.next) {
      return getUser(rs)
    }else {
      null;
    }
    user;
  }

  private def getUser(rs: SqlRowSet): User = {

    var user = new User {
      name = rs.getString("username");
      id = rs.getInt("user_id")
      posts = rs.getInt("user_posts")
      bio = rs.getString("user_biography");
    };
    user;
  }

  def getAllUsersSortedByName(limit:Int)  = {
    getAllUsers("select * from jforum_users where deleted is null order by username",limit);
  }
  def getAllUsersSortedByUserIdDesc(limit:Int)  = {
    getAllUsers("select * from jforum_users where deleted is null order by user_id desc",limit);
  }

  def getAllUsersSortedByPostsAsc(limit:Int)  = {
    getAllUsers("select * from jforum_users where deleted is null order by user_posts asc",limit);
  }
  def getAllUsersSortedByPostsDesc(limit:Int)  = {
    getAllUsers("select * from jforum_users where deleted is null order by user_posts desc",limit);
  }
  def getAllUsers(limit:Int): List[User] = {
    getAllUsers("select * from jforum_users where deleted is null ",limit);

  }
  def getUsersWithNameContaining(name:String):List[User]  = {
    getAllUsers("select * from jforum_users where deleted is null and username like '%"+name+"%' order by user_posts desc",0)
  }
  def toJavaList[T](list:List[T]):java.util.List[T] = {
    var arrayList = new java.util.ArrayList[T]();
    list.foreach(x=>arrayList.add(x))
    arrayList;
  }
  def deleteUsersWithIp(ip:String) {
    getUsersWithIp(ip).foreach(x=>deleteUser(x.id))
  }
  def deleteUser(username:String):Unit  = {
    println("Deleting user "+username)
    deleteUser(getUser(username).id)
  }
  def deleteUser(userId:Int):Unit = {
    executeUpdate("update jforum_users set deleted=1 where user_id="+userId)
    deleteUsersTopics(userId);
    deleteUsersPosts(userId);
    executeUpdate("delete from jforum_users where user_id="+userId)

  }
  def getUsersWithIp(ip:String):List[User] =  {
    getAllUsers("select * from jforum_users where user_id in(select distinct(user_id) from jforum_posts where poster_ip='"+ip+"')",0);
  }
  def getAllUsers(sql:String,limit:Int) = {
    var s = sql;
    if(limit>0) s = s + " limit "+limit;
    var rs: SqlRowSet = executeQuery(s)
    var users   = new scala.collection.mutable.ListBuffer[User]();
    

    while (rs.next) {
      users.append(getUser(rs))
    }
    users.toList;
  }
  def getTopic(rs:SqlRowSet):Topic = {
    new Topic()
      {
        userId = rs.getInt("user_id")
        id = rs.getInt("topic_id")
        title = rs.getString("topic_title")
     }
  }

  def getTopic(topicId:Int):Topic = {
    getTopic(executeQuery("select * from jforum_topics where topic_id="+topicId))
  }
  def getUsersTopics(userId:Int):List[Topic]  = {
    var sql = "select * from jforum_topics where user_id="+userId;
    var rs = executeQuery(sql)
    var topics   = new scala.collection.mutable.ListBuffer[Topic]();
    while(rs.next()) {
      topics.append(getTopic(rs));

    }
    topics.toList;
  }

  def getPost(rs:SqlRowSet)  = {
    new Post()
      {
        userId = rs.getInt("user_id")
        id = rs.getInt("post_id")
        ip = rs.getString("poster_ip")
        text = rs.getString("post_text")
     }
  }
  def getPosts(sql:String ) = {
    var rs = executeQuery(sql)
    var posts   = new scala.collection.mutable.ListBuffer[Post]();
    while(rs.next()) {
      posts.append(getPost(rs));
    }
    posts.toList;
  }
  def getTopicsPosts(topicId:Int):List[Post]  = getPosts("select * from jforum_posts inner join jforum_posts_text  on   jforum_posts.post_id = jforum_posts_text.post_id where jforum_posts.topic_id = "+topicId)

  def getUsersPosts(userId:Int):List[Post]  = getPosts("select * from jforum_posts inner join jforum_posts_text  on   jforum_posts.post_id = jforum_posts_text.post_id where jforum_posts.user_id = "+userId)


  def getDataSource: DataSource = pool;

  def deleteUsersTopics(username:String):Unit = deleteUsersTopics(getUser(username).id)
  def deleteUsersTopics(userId:Int):Unit  = {
    //executeUpdate("delete  jforum_topics,jforum_posts,jforum_posts_text from jforum_topics,jforum_posts,jforum_posts_text where  (jforum_topics.topic_id = jforum_posts.topic_id and  jforum_posts.post_id = jforum_posts_text.post_id)  and jforum_topics.user_id =" +userId);
    getUsersTopics(userId).foreach(x=>deleteTopic(x.id));

  }
  def deleteUsersPosts(userId:Int) {
    getUsersPosts(userId).foreach(x=>deletePost(x.id));
  }
  def getAllUsersWhoPostedFromIp(ip:String):List[User] =  {
    var rs =  executeQuery("select distinct(user_id) from jforum_posts where poster_ip='"+ip+"'");
    var users = new scala.collection.mutable.ListBuffer[User]();
    while(rs.next()) {
      users.add(getUser(rs.getInt("user_id")));
    }
    users.toList
  }
  def deleteAllUsersAssociatedWithSameIpAs(username:String) = getAllAssociatedUsersWithSameIpAs(username).foreach(x=>deleteUser(x.id))
  
  def getAllAssociatedUsersWithSameIpAs(username:String):List[User] = getAllIps(getUser(username).id).map(x=>getUsersWithIp(x)).flatMap(s=>s).distinct
  def getAllIps(username:String):List[String] = getAllIps(getUser(username).id);
  def getAllIps(userId:Int):List[String] = {
    var rs =  executeQuery("select distinct(poster_ip) from jforum_posts where user_id="+userId);
    var ips = new scala.collection.mutable.ListBuffer[String]();
    while(rs.next()) {
      ips.add(rs.getString("poster_ip"));
    }
    ips.toList;
  }
  def deleteTopic(topicId:Int) {
    var posts = getTopicsPosts(topicId).foreach(x=>deletePost(x.id))
    //println("DELETING TOPIC "+topicId)
    executeUpdate("delete from jforum_topics where topic_id="+topicId);
  }
  def deletePost(id:Int)  = List("delete from jforum_posts_text where post_id="+id ,"delete from jforum_posts  where post_id="+id).foreach(executeUpdate)
  private  def executeUpdate(sql: String): Unit = $.execute(sql)
  private def executeQuery(sql: String): SqlRowSet = $.queryForRowSet(sql)
  private  def $(): JdbcTemplate = new JdbcTemplate(getDataSource)



  
}
object ForumMain {
    def main(args: Array[String]) {
      var f = new ForumFunctions();
      var user = f.getUser("Larry Holmes");
      var l =  f.getAllUsersSortedByUserIdDesc(100);
      l.foreach(x=>println(x.id+" "+x.getBio()));

      //println(q.getJobs());
    }
}